Subject: Re: [bitcoindev] The case for privatizing Bitcoin Core

From: waxwing/ AdamISZ <[email-masked]>
Date: Mon, 16 Jun 2025 08:14:44 -0700 (PDT)

My personal opinion is that the best solution is to create a very strong 
ruleset on disallowing any non-technical contribution on github, and 
applying that rule rigorously no matter whether the content *feels* 
acceptable or not, and no matter how well respected the contributor is and 
might rightfully be given some slack. This would be for PRs; for Issues, I 
don't know how much of a similar problem you have, but templates aren't bad 
I guess.

Such extreme discipline is only needed in that repo, virtually no other 
repo needs it.

I also do realize this could end up a bit of a weak-sauce suggestion 
compared to others in this thread (I quite like Andrew's suggestion but, 
not sure it's exactly the right one).

This would have to be accompanied by a very strong cohesion around what 
*is* the correct forum for technically-adjacent bitcoin policy discussion 
(as just one example, advocating for or against soft forks goes in this 
bucket), and also tonally to *encourage* such discussion; that 
encouragement would have to be broadcast from the github repo itself, 
certainly in messages to people whose discussion contribution is blocked. 
Obviously it would have to be noted elsewhere too like the main 
distribution website for the software.

Unfortunately I don't think this mailing list *quite* fits the job, though 
it's close ... on the other hand, where else? If this list is manually 
moderated (as I believe it is), do we have a bitcoin-"policy" mailing list 
or other channel?

I think the biggest problems arise when you insist that there is *no* place 
for what you see as "brigading", "sock puppetry" etc. I have seen several 
times in the past (most notably around the blocksize wars) where many 
highly respected engineers dismissed all opposing opinions as sock 
puppetry. This is not realistic, nor is it healthy. If you stuff all 
contrary opinions (uneducated or not!) into a garbage bin that you label 
"politics" (imagine the phrase "go and discuss it on bitcoin-politics" with 
the tacit assumption that no one serious is ever going to read that 
dumpster fire), it invites the exact conflict you're trying to avoid. I 
suggest "bitcoin policy" as a general title for such things, because 
bitcoin does indeed have "policies" in the general sense (not just the 
technical meaning of "policy" in bitcoin-the-software but also consensus 
itself is a flavor of policy). If it doesn't end up being a place that 
serious people talk seriously, then of course it will have failed in the 
intention.

Cheers,
AdamISZ/waxwing

On Sunday, June 15, 2025 at 1:30:24 PM UTC-3 Andrew Poelstra wrote:

> I have a few thoughts about this -- bearing in mind that I am a drive-by
> contributor to Core, at best, and don't have much personal opinion other
> than maybe "I wish it were easier to get stuff in".
>
> 1. I think that Antoine is correct that "it's easier and more natural"
> is a bigger motivation for "office work" than is the fear of brigade.
> So one thing is that any change to public processes shouldn't make it
> _harder_ for people to collaborate online, since that could push
> people more to in-person fora and we'd just have the worst of both
> worlds. Or at least, anyone making such a change should have a lot of
> confidence that the increased friendliness to earnest contributors
> would outweigh the extra friction.
>
> 2. On the other hand, fear of brigades _does_ clearly have a nonzero
> chilling effect. I certainly think about it when publicly communicating
> near the project, and I commonly bring it up when doing things in
> rust-bitcoin (i.e. "fortunately, we're not Core, so we can just do
> [some change that would constrain wallet workflows, or which could
> make ordinals particularly hard, or particularly easy, or whatever]"
> and not have to worry about fallout.)
>
> So at the very least, it's a factor that discourages some external
> developers from being bigger contributors to the project.
>
> 3. And of course, it's not just obvious brigades -- when one or two
> nontechnical people show up with strong political views about
> something which really is not a political change (or at least,
> doesn't have the political effect they believe it does, because of
> their own misunderstanding), it's still discouraging and sometimes
> stressful. And this happens all the time around mempool policy,
> even if PRs with 100+ comments that get locked are fairly rare.
>
> 4. However, after (ironically) discussing this email off-list with a
> bunch of people, I think that these problems stem from a fairly small
> cultural issue: that the Github repo appears to be a totally open
> forum where anyone is welcome to participate, even in code review
> threads, because technically anybody _can_ participate with no
> obvious sense that they're leaving X and entering somebody's
> workplace.
>
> And _this_, IMHO, might be solvable by something extremely simple. It
> might be sufficient to just move from Github to Gitlab or Codeberg or
> something where far fewer people have accounts. It would probably be
> sufficient to just find a platform where you have to register on the
> Core repo somehow then wait 24 hours before you can post, with the
> implication that if you're not there to contribute technically, you
> might lose your access. (This is true on Github but the only
> mechanism is that you can be banned from the org, something that
> feels heavy and scary for maintainers to use -- I really hate doing
> this to non-bots on rust-bitcoin and I don't even have to worry that
> they'll go on twitter to scream censorship and that I'm taking over
> Bitcoin or whatever -- and is also more-or-less invisible to users
> until it happens to them, so it's not an effective deterrent.)
>
> It would certainly be effective to put a strong technical barrier,
> e.g. you have to produce a custom mining share to join, or a strong
> social barrier, e.g. you need personal invitations from two people.
>
> But I think such tech barriers would be unnecessary and the social
> barriers wouldn't be worth the cries of censorship and centralization
> that they'd inevitably (and somewhat reasonably) cause.
>
> 5. I don't see much of benefit to making the repo *unreadable* to
> outsiders. It sorta prevents linking on Twitter but if we expect
> there to be mirrors, people can just link to the mirrors.
>
>
> Again, it's not my project and I don't mean to advocate for anything in
> particular. Just trying to organize thinking on the topic a bit.
>
>
> -- 
> Andrew Poelstra
> Director, Blockstream Research
> Email: apoelstra at wpsoftware.net
> Web: https://www.wpsoftware.net/andrew
>
> The sun is always shining in space
> -Justin Lewis-Webster
>
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/4ad72033-dac1-4a4d-a432-1cc525f92e6dn%40googlegroups.com.